//
//  KQ1_ViewController.m
//  KingsQueens12
//
//  Created by Terry Payne on 24/10/2012.
//  Copyright (c) 2012 Terry Payne. All rights reserved.
//

#import "KQ1_ViewController.h"

#define TITLE @"title"
#define MONARCHS @"monarchs"
#define EPOCH @"epoch"

#define NAME @"name"
#define REIGNED @"reigned"

@interface KQ1_ViewController ()

@property (strong, nonatomic) NSArray *myDataArray;
@property (strong, nonatomic) NSArray *myKingsQueensModel;

@end

@implementation KQ1_ViewController

//- (void) initKingsQueensDataModel {
//    // ==================
//    // House of Lancaster
//    NSDictionary *lancaster = @{TITLE:@"House of Lancaster",
//                                MONARCHS:@[@"Henry IV", @"Henry V", @"Henry VI"],
//                                EPOCH:@"From 1399-1471"};
//    
//    // ==================
//    // House of York
//    NSDictionary *york = @{TITLE:@"House of York",
//                            MONARCHS:@[@"Edward IV", @"Edward V", @"Richard III"],
//                            EPOCH:@"From 1461-1485"};
//    
//    // ==================
//    // House of Tudor
//    NSDictionary *tudor = @{TITLE:@"House of Tudor",
//                            MONARCHS:@[@"Henry VII", @"Henry VIII", @"Edward VI", @"Jane", @"Mary I", @"Elizabeth I"],
//                            EPOCH:@"From 1485-1603"};
//    
//    // ==================
//    // House of Stuart
//    NSDictionary *stuart = @{TITLE:@"House of Stuart",
//                        MONARCHS:@[@"James I", @"Charles I", @"Charles II", @"James II",
//                                    @"Mary II", @"William III", @"Anne"],
//                        EPOCH:@"From 1603-1707"};
//        
//    [self setMyKingsQueensModel:@[lancaster, york, tudor, stuart]];
//         
//}

- (void) initKingsQueensDataModel {
    
    [self setMyKingsQueensModel:nil];
    // Generate the URL request for the JSON data
    NSURL *url = [NSURL URLWithString:@"http://www.csc.liv.ac.uk/people/trp/Teaching_Resources/COMP327/Monarchs2.json"];
    
    // Get the contents of the URL
    NSData *data = [NSData dataWithContentsOfURL:url];
    NSError *error;
    [self setMyKingsQueensModel:[NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:&error]];
    
}

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
        // =================================================
        [self setMyDataArray:@[@"Henry VII", @"Henry VIII",
         @"Edward VI", @"Jane", @"Mary I", @"Elizabeth I"]];
        [self initKingsQueensDataModel];
        // =================================================        
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return [[self myKingsQueensModel] count];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    NSDictionary *house = [[self myKingsQueensModel] objectAtIndex:section];
    NSArray *monarchs = [house objectForKey:MONARCHS];
    return [monarchs count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
        NSLog(@"We've just allocated a new cell for section %d, row %d", [indexPath section], [indexPath row]);
    } else {
        NSLog(@"An old cell was dequeued for section %d, row %d", [indexPath section], [indexPath row]);
    }
    
    // Configure the cell...
    // [[cell textLabel] setText:[[self myDataArray] objectAtIndex:[indexPath row]]];
    
    // Configure the cell...
    // NSDictionary *house = [[self myKingsQueensModel] objectAtIndex:[indexPath section]];
    // NSArray *monarchs = [house objectForKey:MONARCHS];
    // [[cell textLabel] setText:[monarchs objectAtIndex:[indexPath row]]];
    
    // Configure the cell...
    NSDictionary *house = [[self myKingsQueensModel] objectAtIndex:[indexPath section]];
    NSArray *monarchs = [house objectForKey:MONARCHS];
    NSDictionary *kingQueen = [monarchs objectAtIndex:[indexPath row]];
    
    [[cell textLabel] setText:[kingQueen objectForKey:NAME]];
    [[cell detailTextLabel] setText:[kingQueen objectForKey:REIGNED]];


    
    return cell;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    // Configure the cell...
    NSDictionary *house = [[self myKingsQueensModel] objectAtIndex:section];
    return [house objectForKey:TITLE];
}

- (NSString *)tableView:(UITableView *)tableView titleForFooterInSection:(NSInteger)section
{
    // Configure the cell...
    NSDictionary *house = [[self myKingsQueensModel] objectAtIndex:section];
    return [house objectForKey:EPOCH];
}
/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
    
    NSDictionary *house = [[self myKingsQueensModel] objectAtIndex:[indexPath section]];
    NSArray *monarchs = [house objectForKey:MONARCHS];
    NSDictionary *kingQueen = [monarchs objectAtIndex:[indexPath row]];
    
    NSString *title = [NSString stringWithFormat:@"You selected %@.",
                       [kingQueen objectForKey:@"name"]];
    
    UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:title
                                                        message:@"Now what?" delegate:nil
                                              cancelButtonTitle:@"Dismiss" otherButtonTitles:nil];
    [alertView show];
    
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    
}

@end
